Index: palm/trunk/SOURCE/modules.f90
===================================================================
--- palm/trunk/SOURCE/modules.f90	(revision 2106)
+++ palm/trunk/SOURCE/modules.f90	(revision 2107)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! Preparation for doxygen comments (Giersch)
 ! 
 ! Former revisions:
@@ -429,6 +429,9 @@
     USE kinds
 
-    REAL(wp), DIMENSION(:), ALLOCATABLE   ::  aex, bex, dex, eex
-
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  aex  !< 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  bex  !< 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  dex  !< 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  eex  !< 
+    
     SAVE
 
@@ -445,73 +448,304 @@
     USE kinds
 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::                                     &
-          c_u_m, c_u_m_l, c_v_m, c_v_m_l, c_w_m, c_w_m_l, ddzu, ddzu_pres,     &
-          dd2zu, dzu, ddzw, dzw, hyp, inflow_damping_factor, l_grid,           &
-          ptdf_x, ptdf_y, p_surf, pt_surf, pt_init, qsws_surf, q_init, q_surf, &
-          rdf, rdf_sc, ref_state, s_init, s_surf, sa_init, shf_surf,           &
-          timenudge, time_surf, time_vert, tmp_tnudge, ug, u_init,             &
-          u_nzb_p1_for_vfc, vg, v_init, v_nzb_p1_for_vfc, w_subs, zu, zw
-
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::                                   &
-          c_u, c_v, c_w, diss_s_e, diss_s_nr, diss_s_pt, diss_s_q,             &
-          diss_s_qr, diss_s_s, diss_s_sa, diss_s_u, diss_s_v, diss_s_w, dzu_mg,&
-          dzw_mg, flux_s_e, flux_s_nr, flux_s_pt, flux_s_q, flux_s_qr,         &
-          flux_s_s, flux_s_sa, flux_s_u, flux_s_v, flux_s_w, f1_mg, f2_mg,     &
-          f3_mg, mean_inflow_profiles, nrs, nrsws, nrswst,                     &
-          ol,                                                                  & !< Obukhov length
-          precipitation_amount, precipitation_rate, ptnudge, pt_slope_ref,     &
-          qnudge, qs, qsws, qswst, qswst_remote, qrs, qrsws, qrswst,           &
-          saswsb, saswst, shf, ss, ssws, sswst, tnudge, td_lsa_lpt, td_lsa_q,  &
-          td_sub_lpt,                                                          &
-          td_sub_q, total_2d_a, total_2d_o, ts, tswst, ug_vert, unudge, us,    &
-          usws, uswst, vnudge, vg_vert, vsws, vswst, wnudge, wsubs_vert,       &
-          z0,                                                                  & !< roughness length for momentum
-          z0h,                                                                 & !< roughness length for heat
-          z0q                                                                    !< roughness length for moisture
-
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::                                 &
-          d, de_dx, de_dy, de_dz, diss, diss_l_e,                              &
-          diss_l_nr, diss_l_pt, diss_l_q, diss_l_qr, diss_l_s, diss_l_sa,      &
-          diss_l_u, diss_l_v, diss_l_w, flux_l_e, flux_l_nr, flux_l_pt,        &
-          flux_l_q, flux_l_qr, flux_l_s, flux_l_sa, flux_l_u, flux_l_v,        &
-          flux_l_w, kh, km, l_wall, prr, p_loc, tend, tric,                    &
-          u_m_l, u_m_n, u_m_r, u_m_s, v_m_l, v_m_n, v_m_r, v_m_s, w_m_l,       &
-          w_m_n, w_m_r, w_m_s
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  c_u_m                  !< 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  c_u_m_l                !< 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  c_v_m                  !< 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  c_v_m_l                !< 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  c_w_m                  !< 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  c_w_m_l                !<    
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  ddzu                   !< 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  ddzu_pres              !< 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  dd2zu                  !< 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  dzu                    !< 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  ddzw                   !< 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  dzw                    !< 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  hyp                    !< 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  inflow_damping_factor  !< 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  l_grid                 !< 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  ptdf_x                 !< 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  ptdf_y                 !< 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  p_surf                 !< 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  pt_surf                !< 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  pt_init                !< 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  qsws_surf              !< 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  q_init                 !< 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  q_surf                 !< 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  rdf                    !< 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  rdf_sc                 !< 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  ref_state              !< 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  s_init                 !< 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  s_surf                 !< 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  sa_init                !< 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  shf_surf               !< 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  timenudge              !< 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  time_surf              !< 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  time_vert              !< 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  tmp_tnudge             !<
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  ug                     !< 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  u_init                 !< 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  u_nzb_p1_for_vfc       !< 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  vg                     !< 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  v_init                 !< 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  v_nzb_p1_for_vfc       !< 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  w_subs                 !< 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  zu                     !< 
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  zw                     !< 
+
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  c_u                   !<
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  c_v                   !<
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  c_w                   !<
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  diss_s_e              !<
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  diss_s_nr             !<     
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  diss_s_pt             !< 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  diss_s_q              !<
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  diss_s_qr             !< 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  diss_s_s              !<
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  diss_s_sa             !< 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  diss_s_u              !<
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  diss_s_v              !<
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  diss_s_w              !< 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  dzu_mg                !<
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  dzw_mg                !<
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  flux_s_e              !<
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  flux_s_nr             !< 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  flux_s_pt             !<
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  flux_s_q              !<
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  flux_s_qr             !<
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  flux_s_s              !<
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  flux_s_sa             !<
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  flux_s_u              !< 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  flux_s_v              !<
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  flux_s_w              !<
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  f1_mg                 !< 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  f2_mg                 !< 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  f3_mg                 !< 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  mean_inflow_profiles  !< 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  nrs                   !< 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  nrsws                 !< 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  nrswst                !< 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  ol                    !< Obukhov length 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  precipitation_amount  !< 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  precipitation_rate    !< 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  ptnudge               !< 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  pt_slope_ref          !< 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  qnudge                !< 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  qs                    !< 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  qsws                  !< 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  qswst                 !< 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  qswst_remote          !< 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  qrs                   !< 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  qrsws                 !< 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  qrswst                !< 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  saswsb                !< 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  saswst                !< 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  shf                   !< 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  ss                    !< 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  ssws                  !< 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  sswst                 !< 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  tnudge                !< 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  td_lsa_lpt            !< 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  td_lsa_q              !< 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  td_sub_lpt            !< 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  td_sub_q              !< 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  total_2d_a            !< 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  total_2d_o            !< 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  ts                    !< 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  tswst                 !< 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  ug_vert               !< 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  unudge                !< 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  us                    !< 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  usws                  !< 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  uswst                 !< 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  vnudge                !< 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  vg_vert               !< 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  vsws                  !< 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  vswst                 !< 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  wnudge                !< 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  wsubs_vert            !< 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  z0                    !< roughness length for momentum
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  z0h                   !< roughness length for heat
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  z0q                   !< roughness length for moisture
+    
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  d          !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  de_dx      !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  de_dy      !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  de_dz      !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  diss       !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  diss_l_e   !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  diss_l_nr  !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  diss_l_pt  !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  diss_l_q   !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  diss_l_qr  !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  diss_l_s   !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  diss_l_sa  !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  diss_l_u   !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  diss_l_v   !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  diss_l_w   !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  flux_l_e   !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  flux_l_nr  !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  flux_l_pt  !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  flux_l_q   !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  flux_l_qr  !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  flux_l_s   !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  flux_l_sa  !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  flux_l_u   !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  flux_l_v   !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  flux_l_w   !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  kh         !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  km         !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  l_wall     !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  prr        !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  p_loc      !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  tend       !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  tric       !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  u_m_l      !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  u_m_n      !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  u_m_r      !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  u_m_s      !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  v_m_l      !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  v_m_n      !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  v_m_r      !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  v_m_s      !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  w_m_l      !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  w_m_n      !<  
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  w_m_r      !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  w_m_s      !< 
 
 #if defined( __nopointer )
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::                         &
-          e, e_p, nr, nr_p, p, prho, pt, pt_p, q, q_p, qc, ql, ql_c, ql_v,     &
-          ql_vp, qr, qr_p, rho_ocean, s, s_p, sa, sa_p, te_m, tnr_m, tpt_m, tq_m,    &
-          tqr_m, ts_m, tsa_m, tu_m, tv_m, tw_m, u, u_p, v, v_p, vpt, w, w_p
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  e          !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  e_p        !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  nr         !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  nr_p       !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  p          !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  prho       !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  pt         !<
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  pt_p       !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  q          !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  q_p        !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  qc         !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  ql         !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  ql_c       !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  ql_v       !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  ql_vp      !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  qr         !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  qr_p       !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  rho_ocean  !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  s          !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  s_p        !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  sa         !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  sa_p       !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  te_m       !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  tnr_m      !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  tpt_m      !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  tq_m       !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  tqr_m      !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  ts_m       !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  tsa_m      !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  tu_m       !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  tv_m       !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  tw_m       !<  
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  u          !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  u_p        !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  v          !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  v_p        !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  vpt        !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  w          !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  w_p        !< 
 #else
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::                         &
-          e_1, e_2, e_3, p, prho_1, nr_1, nr_2, nr_3, pt_1, pt_2, pt_3, q_1,   &
-          q_2, q_3, qc_1, ql_v, ql_vp, ql_1, ql_2, qr_1, qr_2, qr_3, rho_1,    &
-          s_1, s_2, s_3, sa_1, sa_2, sa_3, u_1, u_2, u_3, v_1, v_2, v_3, vpt_1,&
-          w_1, w_2, w_3
-
-    REAL(wp), DIMENSION(:,:,:), POINTER ::                                     &
-          e, e_p, nr, nr_p, prho, pt, pt_p, q, q_p, qc, ql, ql_c, qr, qr_p,    &
-          rho_ocean, s, s_p, sa, sa_p, te_m, tnr_m, tpt_m, tq_m, tqr_m, ts_m,        &
-          tsa_m, tu_m, tv_m, tw_m, u, u_p, v, v_p, vpt, w, w_p
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  e_1     !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  e_2     !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  e_3     !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  p       !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  prho_1  !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  nr_1    !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  nr_2    !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  nr_3    !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  pt_1    !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  pt_2    !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  pt_3    !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  q_1     !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  q_2     !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  q_3     !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  qc_1    !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  ql_v    !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  ql_vp   !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  ql_1    !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  ql_2    !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  qr_1    !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  qr_2    !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  qr_3    !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  rho_1   !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  s_1     !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  s_2     !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  s_3     !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  sa_1    !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  sa_2    !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  sa_3    !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  u_1     !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  u_2     !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  u_3     !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  v_1     !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  v_2     !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  v_3     !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  vpt_1   !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  w_1     !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  w_2     !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  w_3     !< 
+
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  e          !< 
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  e_p        !< 
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  nr         !< 
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  nr_p       !< 
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  prho       !< 
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  pt         !< 
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  pt_p       !< 
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  q          !< 
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  q_p        !< 
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  qc         !< 
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  ql         !< 
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  ql_c       !< 
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  qr         !< 
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  qr_p       !< 
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  rho_ocean  !< 
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  s          !< 
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  s_p        !< 
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  sa         !< 
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  sa_p       !< 
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  te_m       !< 
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  tnr_m      !< 
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  tpt_m      !< 
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  tq_m       !< 
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  tqr_m      !< 
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  ts_m       !< 
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  tsa_m      !< 
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  tu_m       !< 
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  tv_m       !< 
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  tw_m       !< 
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  u          !< 
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  u_p        !< 
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  v          !< 
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  v_p        !< 
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  vpt        !< 
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  w          !< 
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  w_p        !< 
 #endif
 
-    REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE ::  rif_wall, tri
-
-    REAL(wp), DIMENSION(:), ALLOCATABLE :: rho_air     !< air density profile on the uv grid
-    REAL(wp), DIMENSION(:), ALLOCATABLE :: rho_air_zw  !< air density profile on the w grid
-    REAL(wp), DIMENSION(:), ALLOCATABLE :: drho_air    !< inverse air density profile on the uv grid
-    REAL(wp), DIMENSION(:), ALLOCATABLE :: drho_air_zw !< inverse air density profile on the w grid
-
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE :: rho_air_mg    !< air density profiles on the uv grid for multigrid
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE :: rho_air_zw_mg !< air density profiles on the w grid for multigrid
-
-    REAL(wp), DIMENSION(:), ALLOCATABLE :: heatflux_input_conversion      !< conversion factor array for heatflux input
-    REAL(wp), DIMENSION(:), ALLOCATABLE :: waterflux_input_conversion     !< conversion factor array for waterflux input
-    REAL(wp), DIMENSION(:), ALLOCATABLE :: momentumflux_input_conversion  !< conversion factor array for momentumflux input
-    REAL(wp), DIMENSION(:), ALLOCATABLE :: heatflux_output_conversion     !< conversion factor array for heatflux output
-    REAL(wp), DIMENSION(:), ALLOCATABLE :: waterflux_output_conversion    !< conversion factor array for waterflux output
-    REAL(wp), DIMENSION(:), ALLOCATABLE :: momentumflux_output_conversion !< conversion factor array for momentumflux output
-
+    REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE ::  rif_wall !< 
+    REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE ::  tri      !< 
+
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  rho_air      !< air density profile on the uv grid
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  rho_air_zw   !< air density profile on the w grid
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  drho_air     !< inverse air density profile on the uv grid
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  drho_air_zw  !< inverse air density profile on the w grid
+
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  rho_air_mg     !< air density profiles on the uv grid for multigrid
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  rho_air_zw_mg  !< air density profiles on the w grid for multigrid
+
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  heatflux_input_conversion       !< conversion factor array for heatflux input
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  waterflux_input_conversion      !< conversion factor array for waterflux input
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  momentumflux_input_conversion   !< conversion factor array for momentumflux input
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  heatflux_output_conversion      !< conversion factor array for heatflux output
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  waterflux_output_conversion     !< conversion factor array for waterflux output
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  momentumflux_output_conversion  !< conversion factor array for momentumflux output
 
     SAVE
@@ -529,20 +763,39 @@
     USE kinds
 
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  lwp_av,                & !< Avg. liquid water path
-                                              precipitation_rate_av, & !< Avg. of precipitation rate
-                                              ol_av,                 & !< Avg. of Obukhov length
-                                              qsws_av,               & !< Avg. of surface moisture flux
-                                              ssws_av,               & !< Avg. of surface scalar flux
-                                              shf_av,                & !< Avg. of surface heat flux
-                                              ts_av,                 & !< Avg. of characteristic temperature scale
-                                              us_av,                 & !< Avg. of friction velocity
-                                              z0_av,                 & !< Avg. of roughness length for momentum
-                                              z0h_av,                & !< Avg. of roughness length for heat
-                                              z0q_av                   !< Avg. of roughness length for moisture
-
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::                         &
-          e_av, lpt_av, nr_av, p_av, pc_av, pr_av, prr_av, pt_av, q_av, qc_av, &
-          ql_av, ql_c_av, ql_v_av, ql_vp_av, qr_av, qv_av, rho_ocean_av, s_av, sa_av,&
-          u_av, v_av, vpt_av, w_av
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  lwp_av                 !< Avg. liquid water path
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  precipitation_rate_av  !< Avg. of precipitation rate
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  ol_av                  !< Avg. of Obukhov length
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  qsws_av                !< Avg. of surface moisture flux
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  ssws_av                !< Avg. of surface scalar flux
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  shf_av                 !< Avg. of surface heat flux
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  ts_av                  !< Avg. of characteristic temperature scale
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  us_av                  !< Avg. of friction velocity
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  z0_av                  !< Avg. of roughness length for momentum
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  z0h_av                 !< Avg. of roughness length for heat
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  z0q_av                 !< Avg. of roughness length for moisture
+
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  e_av          !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  lpt_av        !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  nr_av         !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  p_av          !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  pc_av         !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  pr_av         !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  prr_av        !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  pt_av         !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  q_av          !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  qc_av         !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  ql_av         !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  ql_c_av       !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  ql_v_av       !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  ql_vp_av      !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  qr_av         !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  qv_av         !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  rho_ocean_av  !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  s_av          !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  sa_av         !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  u_av          !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  v_av          !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  vpt_av        !< 
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  w_av          !< 
   
  END MODULE averaging
